#include "perseus.h"
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>

#define TEST0 "PERSEUS"

int main(int argc, char * argv[]) 
 {
  libperseus_hl_t lht;
  unsigned char *encoded_data, *decoded_data;
  unsigned long int encoded_data_size, decoded_data_size;
  unsigned char clair[512];

  memset(&lht, '\0', sizeof(libperseus_hl_t));
  memset(clair, '\0', 512);

  memcpy(clair, TEST0, strlen(TEST0));

  perseus_init( &lht, alea(), alea(), alea(), alea() );

  printf("CLAIR = %s\n", clair);
  
  encoded_data = perseus_code( &lht, clair, (unsigned long int)(strlen((char *)clair)), &encoded_data_size );
  if (encoded_data == NULL) {
      printf("Error ....\n");
      exit(-1);
  }
  printf("ENCODED DATA @ 0x%lx %lx\n", (unsigned long)(encoded_data), encoded_data_size);
  
  decoded_data = perseus_decode( &lht, encoded_data, encoded_data_size, &decoded_data_size );
  if (decoded_data == NULL) {
      printf("Error ....\n");
      exit(-1);
  }
  printf("DECODED DATA @ %s 0x%lx %lx\n", decoded_data, (unsigned long)(decoded_data), decoded_data_size);

  perseus_destroy( &lht );

  return(0);
 }
