require './ffi-perseus'

# We initialize a LibPerseus_ht_t struct with 4 random numbers in range [0.0, 1.0]
prng = Random.new()
p = Perseus::LibPerseus_hl_t.new
ret = Perseus.init(p, prng.rand(), prng.rand(), prng.rand(), prng.rand() )

# We code a simple string. As the function returns the size, we need a pointer to an int
# so we create one with FFI::MemoryPointer
clair = "PERSEUS test"
encoded_data_size = FFI::MemoryPointer.new :ulong
encoded_data = Perseus.code(p, clair, clair.length, encoded_data_size)

print "endecoded size = ",encoded_data_size.get_int(0), "\n"

# Same things for the decoding
decoded_data_size = FFI::MemoryPointer.new :ulong
decoded_data = Perseus.decode(p, encoded_data, encoded_data_size.get_int(0), decoded_data_size)

print "decoded size = ",decoded_data_size.get_int(0), "\n"
print "decoded : ", decoded_data.get_string(0),"\n"

Perseus.destroy(p)
